
#ifndef Map_hpp
#define Map_hpp

#include "cocostudio/CocoStudio.h"
#include "ui/CocosGUI.h"
#include "Role.hpp"
#include "Tile.hpp"

enum BType {BTYPE_TOWER=0, BTYPE_ELC, BTYPE_FLAG_ROLE, BTYPE_FLAG_TOWER, BTYPE_FLAG_EH, BTYPE_FLAG_EV};

USING_NS_CC;
using namespace ui;

class CMap : public Layer {
public:
    CMap(void *parent, bool small);
    ~CMap();
    bool createMap(ScrollView *scroll);
    void setOtherMap(CMap *other, CMap *small){m_othermap=other;m_smallmap=small;}
    
    Vec2 getMovablePos(Vec2 pos, MEAction dir); //获得可经过的位置
    bool moveRole(bool edison, MEAction action, bool conmove);    //移动人物
    bool setElc(BType type, Vec2 coord, bool edison); //设置对象
    bool delElc(Vec2 coord);    //删除对象
    int isInLine(Vec2 coord);  //判断是否在电流中
    
    CTile *getTileByCoord(Vec2 coord); //根据坐标得到瓦片
    TMXTiledMap *getMap(){return m_map;}
    CRole *getRole(bool edison);
    
protected:
    void callback(Node* sender, void* data);
    Vec2 convertToTileCoord(Vec2 pos);  //屏幕坐标转瓦片坐标
    Vec2 convertToPosition(Vec2 coord); //瓦片坐标转屏幕坐标
    
    bool setConPosition(MEAction action);   //设置容器位置
    bool updateLines(Vec2 coord); //更新电流
    bool updateDirectLine(Vec2 coord, MEAction dir);    //更新一个方向的电流
    
private:
    void    *m_parent;  //地图场景
    bool    m_small;
    
    ScrollView  *m_cont;
    TMXTiledMap *m_map;
    CMap *m_othermap;
    CMap *m_smallmap;
    
    CTile   ***m_tiles;   //地图瓦片
    int     m_wid;
    int     m_hei;
    
    CRole   *m_roleE;
    CRole   *m_roleT;

    __CCCallFuncND  *m_cf;          //回调函数
};

#endif /* Map_hpp */
