
#ifndef MapScene_hpp
#define MapScene_hpp

#include "Map.hpp"
#include "Tower.hpp"
#include "WinLayer.hpp"
#include "cocos2d.h"
#include "ui/CocosGUI.h"
#include "cocostudio/CocoStudio.h"

using namespace std;
using namespace cocos2d;
using namespace ui;

#define GAME_TIME               300 //游戏限时
#define TILE_TOWER_DISTANCE     6   //电塔距离

class CMapScene : public cocos2d::Layer {
public:
    static cocos2d::Scene* createScene();
    ~CMapScene();
    
    virtual bool init();
    
    CREATE_FUNC(CMapScene);
    void onKeyPressed(EventKeyboard::KeyCode keyCode, Event* event);
    void onReturn(Ref *pSender);
    bool showWinLayer(bool edison); //显示胜利界面
    bool isResult();
    int updateTowerCount(); //更新电塔数量
    
    CTower *addTower(Vec2 coord, bool edison);   //添加一个电塔
    bool addTower(CTower *tower);   //添加一个电塔
    CTower *getTowerByCoord(Vec2 coord);    //根据坐标获得电塔
    CTower *getTowerByDirect(Vec2 coord, MEAction dir); //根据坐标一个方向获得电塔

    bool lineInOne(bool edison);    //判断是否连成一条线
    
protected:
    void onTimer(float fDelta); //计时函数
    
    Vec2 convertToHashCoord(Vec2 coord);    //把电塔瓦片坐标转换成二维坐标
    
private:
    Node        *m_rootNode;
    CWinLayer   *m_winlayer;
    
    CMap    *m_mapE;
    CMap    *m_mapT;
    CMap    *m_mapS;
    
    list<CTower *>     m_towers;    //所有的电塔
    int     m_time; //计时器

};

#endif /* MapScene_hpp */
