
#ifndef Role_hpp
#define Role_hpp

using namespace std;
using namespace cocos2d;

enum MEAction {ACTION_DOWN, ACTION_LEFT, ACTION_RIGHT, ACTION_UP};
enum MEState {STATE_IDLE, STATE_MOVE, STATE_DIE};

#include <stdio.h>


#include "Role.hpp"

class CRole {
    
public:
    CRole();
    
    bool createRole(Node *node, TMXTiledMap *map, bool edison, Vec2 pos, Vec2 coord);
    bool moveOnce(Vec2 coord, Vec2 pos, MEAction action, CallFunc *callback);
    
    void setState(MEState state){m_state=state;}
    Vec2 getCoord(){return m_coord;}
    bool setCP(Vec2 pos, Vec2 coord);   //设置人物的位置
    bool isEdison(){return m_man;}
    bool die(); //死亡
    
protected:
    bool setAction(MEAction action);

private:
    Node    *m_node;
    bool    m_man;  //爱迪生/特斯拉
    
    TMXTiledMap *m_map;
    
    Vec2    m_coord;
    MEState m_state;
    
};

#endif /* Role_hpp */
