
#include "WinLayer.hpp"
#include "MapScene.hpp"
#include "HelloWorldScene.h"
#include "ui/CocosGUI.h"

using namespace ui;

CWinLayer::CWinLayer(Node *node, void *parent) {
    this->m_node = node;
    this->m_parent = parent;
    m_node->setLocalZOrder(200);
    
    auto btn = static_cast<Button *>(m_node->getChildByName("return"));
    btn->addClickEventListener(CC_CALLBACK_1(CWinLayer::onReturn, this));
}

CWinLayer::~CWinLayer() {
    
}

bool CWinLayer::showLayer(bool edison) {
    if (m_node == NULL) {
        return false;
    }
    auto sign = static_cast<ImageView *>(m_node->getChildByName("figure"));
    sign->loadTexture(edison?"edison_f.png":"tesla_f.png");
    auto text = static_cast<Text *>(m_node->getChildByName("text"));
    text->setString(edison?"Edison":"Tesla");
    setNodeVisible(true);
    HelloWorld::playSE("win.mp3");
    return true;
}

void CWinLayer::setNodeVisible(bool show) {
    if (this->m_node != NULL) {
        this->m_node->setVisible(show);
    }
}

void CWinLayer::onReturn(Ref *pSender) {
    ((CMapScene *)m_parent)->onReturn(pSender);
}
